## jackd2 1.9.20~dfsg

=== wscript ===
#! /usr/bin/python3
# encoding: utf-8
from __future__ import print_function

import os
import shutil
import sys

from waflib import Logs, Options, Task, Utils
from waflib.Build import BuildContext, CleanContext, InstallContext, UninstallContext

VERSION='1.9.20'
APPNAME='jack'
JACK_API_VERSION = '0.1.0'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

# lib32 variant name used when building in mixed mode
lib32 = 'lib32'

def display_feature(conf, msg, build):
    if build:
        conf.msg(msg, 'yes', color='GREEN')
    else:
        conf.msg(msg, 'no', color='YELLOW')

def check_for_celt(conf):
    found = False
    for version in ['11', '8', '7', '5']:
        define = 'HAVE_CELT_API_0_' + version
        if not found:
            try:
                conf.check_cfg(
                        package='celt >= 0.%s.0' % version,
                        args='--cflags --libs')
                found = True
                conf.define(define, 1)
                continue
            except conf.errors.ConfigurationError:
                pass
        conf.define(define, 0)

    if not found:
        raise conf.errors.ConfigurationError

def options(opt):
    # options provided by the modules
    opt.load('compiler_cxx')
    opt.load('compiler_c')
    opt.load('autooptions');

    opt.load('xcode6')

    opt.recurse('compat')

    # install directories
    opt.add_option('--htmldir', type='string', default=None, help='HTML documentation directory [Default: <prefix>/share/jack-audio-connection-kit/reference/html/')
    opt.add_option('--libdir', type='string', help='Library directory [Default: <prefix>/lib]')
    opt.add_option('--libdir32', type='string', help='32bit Library directory [Default: <prefix>/lib32]')
    opt.add_option('--pkgconfigdir', type='string', help='pkg-config file directory [Default: <libdir>/pkgconfig]')
    opt.add_option('--mandir', type='string', help='Manpage directory [Default: <prefix>/share/man/man1]')

    # options affecting binaries
    opt.add_option('--platform', type='string', default=sys.platform, help='Target platform for cross-compiling, e.g. cygwin or win32')
    opt.add_option('--mixed', action='store_true', default=False, help='Build with 32/64 bits mixed mode')
    opt.add_option('--debug', action='store_true', default=False, dest='debug', help='Build debuggable binaries')
    opt.add_option('--static', action='store_true', default=False, dest='static', help='Build static binaries (Windows only)')

    # options affecting general jack functionality
    opt.add_option('--classic', action='store_true', default=False, help='Force enable standard JACK (jackd) even if D-Bus JACK (jackdbus) is enabled too')
    opt.add_option('--dbus', action='store_true', default=False, help='Enable D-Bus JACK (jackdbus)')
    opt.add_option('--autostart', type='string', default='default', help='Autostart method. Possible values: "default", "classic", "dbus", "none"')
    opt.add_option('--profile', action='store_true', default=False, help='Build with engine profiling')
    opt.add_option('--clients', default=256, type='int', dest='clients', help='Maximum number of JACK clients')
    opt.add_option('--ports-per-application', default=2048, type='int', dest='application_ports', help='Maximum number of ports per application')
    opt.add_option('--systemd-unit', action='store_true', default=False, help='Install systemd units.')

    opt.set_auto_options_define('HAVE_%s')
    opt.set_auto_options_style('yesno_and_hack')

    # options with third party dependencies
    doxygen = opt.add_auto_option(
            'doxygen',
            help='Build doxygen documentation',
            conf_dest='BUILD_DOXYGEN_DOCS',
            default=False)
    doxygen.find_program('doxygen')
    alsa = opt.add_auto_option(
            'alsa',
            help='Enable ALSA driver',
            conf_dest='BUILD_DRIVER_ALSA')
    alsa.check_cfg(
            package='alsa >= 1.0.18',
            args='--cflags --libs')
    firewire = opt.add_auto_option(
            'firewire',
            help='Enable FireWire driver (FFADO)',
            conf_dest='BUILD_DRIVER_FFADO')
    firewire.check_cfg(
            package='libffado >= 1.999.17',
            args='--cflags --libs')
    iio = opt.add_auto_option(
            'iio',
            help='Enable IIO driver',
            conf_dest='BUILD_DRIVER_IIO')
    iio.check_cfg(
            package='gtkIOStream >= 1.4.0',
            args='--cflags --libs')
    iio.check_cfg(
            package='eigen3 >= 3.1.2',
            args='--cflags --libs')
    portaudio = opt.add_auto_option(
            'portaudio',
            help='Enable Portaudio driver',
            conf_dest='BUILD_DRIVER_PORTAUDIO')
    portaudio.check(header_name='windows.h') # only build portaudio on windows
    portaudio.check_cfg(
            package='portaudio-2.0 >= 19',
            uselib_store='PORTAUDIO',
            args='--cflags --libs')
    winmme = opt.add_auto_option(
            'winmme',
            help='Enable WinMME driver',
            conf_dest='BUILD_DRIVER_WINMME')
    winmme.check(
            header_name=['windows.h', 'mmsystem.h'],
            msg='Checking for header mmsystem.h')

    celt = opt.add_auto_option(
            'celt',
            help='Build with CELT')
    celt.add_function(check_for_celt)
    opt.add_auto_option(
            'example-tools',
            help='Build with jack-example-tools',
            conf_dest='BUILD_JACK_EXAMPLE_TOOLS',
            default=True,
    )

    # Suffix _PKG to not collide with HAVE_OPUS defined by the option.
    opus = opt.add_auto_option(
            'opus',
            help='Build Opus netjack2')
    opus.check(header_name='opus/opus_custom.h')
    opus.check_cfg(
            package='opus >= 0.9.0',
            args='--cflags --libs',
            define_name='HAVE_OPUS_PKG')

    samplerate = opt.add_auto_option(
            'samplerate',
            help='Build with libsamplerate')
    samplerate.check_cfg(
            package='samplerate',
            args='--cflags --libs')
    sndfile = opt.add_auto_option(
            'sndfile',
            help='Build with libsndfile')
    sndfile.check_cfg(
            package='sndfile',
            args='--cflags --libs')
    readline = opt.add_auto_option(
            'readline',
            help='Build with readline')
    readline.check(lib='readline')
    readline.check(
            header_name=['stdio.h', 'readline/readline.h'],
            msg='Checking for header readline/readline.h')
    sd = opt.add_auto_option(
            'systemd',
            help='Use systemd notify')
    sd.check(header_name='systemd/sd-daemon.h')
    sd.check(lib='systemd')
    db = opt.add_auto_option(
            'db',
            help='Use Berkeley DB (metadata)')
    db.check(header_name='db.h')
    db.check(lib='db')
    zalsa = opt.add_auto_option(
            'zalsa',
            help='Build internal zita-a2j/j2a client')
    zalsa.check(lib='zita-alsa-pcmi')
    zalsa.check(lib='zita-resampler')

    # dbus options
    opt.recurse('dbus')

    # this must be called before the configure phase
    opt.apply_auto_options_hack()

def detect_platform(conf):
    # GNU/kFreeBSD and GNU/Hurd are treated as Linux
    platforms = [
        # ('KEY, 'Human readable name', ['strings', 'to', 'check', 'for'])
        ('IS_LINUX',   'Linux',   ['gnu0', 'gnukfreebsd', 'linux', 'posix']),
        ('IS_FREEBSD', 'FreeBSD', ['freebsd']),
        ('IS_MACOSX',  'MacOS X', ['darwin']),
        ('IS_SUN',     'SunOS',   ['sunos']),
        ('IS_WINDOWS', 'Windows', ['cygwin', 'msys', 'win32'])
    ]

    for key,name,strings in platforms:
        conf.env[key] = False

    conf.start_msg('Checking platform')
    platform = Options.options.platform
    for key,name,strings in platforms:
        for s in strings:
            if platform.startswith(s):
                conf.env[key] = True
                conf.end_msg(name, color='CYAN')
                break


def configure(conf):
    conf.load('compiler_cxx')
    conf.load('compiler_c')

    detect_platform(conf)

    if conf.env['IS_WINDOWS']:
        conf.env.append_unique('CCDEFINES', '_POSIX')
        conf.env.append_unique('CXXDEFINES', '_POSIX')
        if Options.options.platform in ('msys', 'win32'):
            conf.env.append_value('INCLUDES', ['/mingw64/include'])
            conf.check(
                header_name='pa_asio.h',
                msg='Checking for PortAudio ASIO support',
                define_name='HAVE_ASIO',
                mandatory=False)

    conf.env.append_unique('CFLAGS', '-Wall')
    conf.env.append_unique('CXXFLAGS', ['-Wall', '-Wno-invalid-offsetof'])
    conf.env.append_unique('CXXFLAGS', '-std=gnu++11')

    if conf.env['IS_FREEBSD']:
        conf.check(lib='execinfo', uselib='EXECINFO', define_name='EXECINFO')
        conf.check_cfg(package='libsysinfo', args='--cflags --libs')

    if not conf.env['IS_MACOSX']:
        conf.env.append_unique('LDFLAGS', '-Wl,--no-undefined')
    else:
        conf.check(lib='aften', uselib='AFTEN', define_name='AFTEN')
        conf.check_cxx(
            fragment=''
                + '#include <aften/aften.h>\n'
                + 'int\n'
                + 'main(void)\n'
                + '{\n'
                + 'AftenContext fAftenContext;\n'
                + 'aften_set_defaults(&fAftenContext);\n'
                + 'unsigned char *fb;\n'
                + 'float *buf=new float[10];\n'
                + 'int res = aften_encode_frame(&fAftenContext, fb, buf, 1);\n'
                + '}\n',
            lib='aften',
            msg='Checking for aften_encode_frame()',
            define_name='HAVE_AFTEN_NEW_API',
            mandatory=False)

        # TODO
        conf.env.append_unique('CXXFLAGS', '-Wno-deprecated-register')

    conf.load('autooptions')

    conf.recurse('compat')

    # Check for functions.
    conf.check(
            fragment=''
                + '#define _GNU_SOURCE\n'
                + '#include <poll.h>\n'
                + '#include <signal.h>\n'
                + '#include <stddef.h>\n'
                + 'int\n'
                + 'main(void)\n'
                + '{\n'
                + '   ppoll(NULL, 0, NULL, NULL);\n'
                + '}\n',
            msg='Checking for ppoll',
            define_name='HAVE_PPOLL',
            mandatory=False)

    # Check for backtrace support
    conf.check(
        header_name='execinfo.h',
        define_name='HAVE_EXECINFO_H',
        mandatory=False)

    conf.recurse('common')
    if Options.options.dbus:
        conf.recurse('dbus')
        if conf.env['BUILD_JACKDBUS'] != True:
            conf.fatal('jackdbus was explicitly requested but cannot be built')
    if conf.env['IS_LINUX']:
        if Options.options.systemd_unit:
            conf.recurse('systemd')
        else:
            conf.env['SYSTEMD_USER_UNIT_DIR'] = None

    if conf.env['BUILD_JACK_EXAMPLE_TOOLS']:
        conf.recurse('example-clients')
        conf.recurse('tools')

    # test for the availability of ucontext, and how it should be used
    for t in ['gp_regs', 'uc_regs', 'mc_gregs', 'gregs']:
        fragment = '#include <ucontext.h>\n'
        fragment += 'int main() { ucontext_t *ucontext; return (int) ucontext->uc_mcontext.%s[0]; }' % t
        confvar = 'HAVE_UCONTEXT_%s' % t.upper()
        conf.check_cc(fragment=fragment, define_name=confvar, mandatory=False,
                      msg='Checking for ucontext->uc_mcontext.%s' % t)
        if conf.is_defined(confvar):
            conf.define('HAVE_UCONTEXT', 1)

    fragment = '#include <ucontext.h>\n'
    fragment += 'int main() { return NGREG; }'
    conf.check_cc(fragment=fragment, define_name='HAVE_NGREG', mandatory=False,
                  msg='Checking for NGREG')

    conf.env['LIB_PTHREAD'] = ['pthread']
    conf.env['LIB_DL'] = ['dl']
    conf.env['LIB_RT'] = ['rt']
    conf.env['LIB_M'] = ['m']

=== common/wscript ===
#! /usr/bin/python3
# encoding: utf-8

import re
import os

def configure(conf):
    conf.env['BUILD_NETLIB'] = conf.env['SAMPLERATE']
    conf.env['BUILD_ADAPTER'] = conf.env['SAMPLERATE']

    if conf.env['IS_WINDOWS']:
        try:
            conf.check(header_name='regex.h', lib='regex', uselib_store='REGEX', define_name='HAVE_REGEX_H')
        except:
            conf.check(header_name='tre/regex.h', lib='tre', uselib_store='REGEX', define_name='HAVE_TRE_REGEX_H')
        conf.check(header_name='winsock2.h', lib='ws2_32', uselib_store='WS2_32', define_name='HAVE_WINSOCK2_H')
        conf.check(header_name=['windows.h', 'mmsystem.h'], lib='winmm', uselib_store='WINMM', define_name='HAVE_MMSYSTEM_H')
        conf.check(header_name=['windows.h', 'psapi.h'], lib='psapi', uselib_store='PSAPI', define_name='HAVE_PSAPI_H')

def create_jack_process_obj(bld, target, sources, uselib = None, framework = None):
    process = bld(features = ['cxx', 'cxxshlib'])
    if not bld.env['IS_WINDOWS']:
        process.env['cxxshlib_PATTERN'] = '%s.so'
    process.defines  = ['HAVE_CONFIG_H','SERVER_SIDE']
    if bld.env['IS_MACOSX']:
        if framework:
            process.framework = framework
        env_includes = ['../macosx', '../posix', '../macosx/coreaudio']
    if bld.env['IS_LINUX']:
        env_includes = ['../linux', '../posix', '../linux/alsa']
    if bld.env['IS_FREEBSD']:
        env_includes = ['../freebsd', '../posix', '../solaris/oss']
    if bld.env['IS_SUN']:
        env_includes = ['../solaris', '../posix', '../solaris/oss']
    if bld.env['IS_WINDOWS']:
        env_includes = ['../windows', '../windows/portaudio']
    process.includes = ['.'] + env_includes + ['jack', '..']
    process.name     = target
    process.target   = target
    process.source   = sources
    if bld.env['IS_LINUX'] or bld.env['IS_MACOSX'] or bld.env['IS_FREEBSD']:
        process.env.append_value('CPPFLAGS', '-fvisibility=hidden')
    process.install_path = '${ADDON_DIR}/'
    process.use = [uselib.name]
    return process

def build(bld):
    common_libsources = [
        'JackActivationCount.cpp',
        'JackAPI.cpp',
        'JackClient.cpp',
        'JackConnectionManager.cpp',
        'ringbuffer.c',
        'JackError.cpp',
        'JackException.cpp',
        'JackFrameTimer.cpp',
        'JackGraphManager.cpp',
        'JackPort.cpp',
        'JackPortType.cpp',
        'JackAudioPort.cpp',
        'JackMidiPort.cpp',
        'JackMidiAPI.cpp',
        'JackEngineControl.cpp',
        'JackShmMem.cpp',
        'JackGenericClientChannel.cpp',
        'shm.c',
        'JackGlobals.cpp',
        'JackTransportEngine.cpp',
        'JackTools.cpp',
        'JackMessageBuffer.cpp',
        'JackEngineProfiling.cpp',
        ]

    includes = ['.', './jack']
    if not bld.variant:
        includes.append('..')
    else:
        includes.append('../..')
    uselib = ['CELT', 'OPUS', 'DB', 'PTHREAD', 'SAMPLERATE']

    if bld.env['IS_LINUX']:
        common_libsources += [
            'JackDebugClient.cpp',
            'timestamps.c',
            'promiscuous.c',
            '../posix/JackPosixThread.cpp',
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixMutex.cpp',
            '../posix/JackSocket.cpp',
            '../linux/JackLinuxFutex.cpp',
            '../linux/JackLinuxTime.c',
            ]
        includes = ['../linux', '../posix'] + includes
        uselib.append('RT')
        uselib.append('DL')

    if bld.env['IS_FREEBSD']:
        common_libsources += [
            'JackDebugClient.cpp',
            'timestamps.c',
            'promiscuous.c',
            '../posix/JackPosixThread.cpp',
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixMutex.cpp',
            '../posix/JackPosixSemaphore.cpp',
            '../posix/JackSocket.cpp',
            '../posix/JackPosixTime.c',
            ]
        includes = ['../freebsd', '../posix'] + includes

    if bld.env['IS_SUN']:
        common_libsources += [
            'JackDebugClient.cpp',
            'timestamps.c',
            'promiscuous.c',
           '../posix/JackPosixThread.cpp',
           '../posix/JackFifo.cpp',
           '../posix/JackPosixProcessSync.cpp',
           '../posix/JackPosixMutex.cpp',
           '../posix/JackSocket.cpp',
           '../solaris/JackSolarisTime.c',
           ]
        includes = ['../solaris', '../posix'] + includes
        uselib.append('RT')

    if bld.env['IS_MACOSX']:
        common_libsources += [
            'JackDebugClient.cpp',
            'timestamps.c',
            'promiscuous.c',
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixThread.cpp',
            '../posix/JackPosixMutex.cpp',
            '../macosx/JackMachThread.mm',
            '../macosx/JackMachSemaphore.mm',
            '../macosx/JackMachSemaphoreServer.mm',
            '../posix/JackSocket.cpp',
            '../macosx/JackMachTime.c',
            ]
        includes = ['../macosx', '../macosx/RPC', '../posix'] + includes

    if bld.env['IS_WINDOWS']:
        common_libsources += [
            '../windows/JackWinMutex.cpp',
            '../windows/JackWinProcessSync.cpp',
            '../windows/JackWinSemaphore.cpp',
            '../windows/JackWinThread.cpp',
            '../windows/JackWinTime.c',
            ]
        includes = ['../windows' ] + includes
        libsuffix = "64" if (bld.env['DEST_CPU'] == "x86_64" and not bld.variant) else ""
        buildbindir = os.path.join('..', bld.path.get_bld().srcpath().rstrip(bld.path.srcpath()))
        staticbuild = bool('BUILD_STATIC' in bld.env and bld.env['BUILD_STATIC'])
        uselib.append('REGEX')
        uselib.append('WS2_32')
        uselib.append('PSAPI')
        uselib.append('WINMM')

    else:
        libsuffix = ""

    clientlib = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
    if bld.env['IS_MACOSX']:
        clientlib.framework = ['CoreAudio', 'Accelerate']
    clientlib.defines = 'HAVE_CONFIG_H'
    clientlib.includes = includes
    clientlib.name = 'clientlib'
    clientlib.target = 'jack'+libsuffix
    clientlib.install_path = '${LIBDIR}'
    clientlib.use = uselib
    if bld.env['IS_WINDOWS']:
        clientlib.env['cxxshlib_PATTERN'] = 'lib%s.dll'
        clientlib.env['cxxstlib_PATTERN'] = 'lib%s.a'
        clientlib.env['implib_PATTERN'] = 'lib%s.dll.a'
        if staticbuild:
            clientlib.env['SHLIB_MARKER'] = ''
        clientlib.env.append_value('LINKFLAGS', ['-static-libstdc++', '--disable-auto-import'])
        clientlib.env.append_value('LINKFLAGS', ['-Wl,--output-def,lib%s.def' % clientlib.target])
        bld.install_files(clientlib.install_path, [os.path.join(buildbindir, 'lib%s.def' % clientlib.target)])

    if bld.env['AUTOSTART_METHOD'] == 'dbus':
        clientlib.use.append('DBUS-1')
    clientlib.source = [] + common_libsources
    clientlib.source += [
        'JackLibClient.cpp',
        'JackLibAPI.cpp',
        'JackMetadata.cpp',
        ]

    if bld.env['IS_LINUX']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_FREEBSD']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_SUN']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_MACOSX']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_WINDOWS']:
        clientlib.source += [
            '../windows/JackWinNamedPipe.cpp',
            '../windows/JackWinNamedPipeClientChannel.cpp',
            '../windows/JackWinServerLaunch.cpp',
            '../windows/JackMMCSS.cpp',
            ]

    if bld.env['IS_MACOSX']:
        clientlib.cnum = bld.env['JACK_API_VERSION']
        clientlib.vnum = bld.env['JACK_VERSION']
    elif not bld.env['IS_WINDOWS']:
        clientlib.vnum = bld.env['JACK_API_VERSION']

    if bld.env['IS_LINUX']:
        clientlib.env.append_value('CPPFLAGS', '-fvisibility=hidden')

    if bld.env['IS_FREEBSD']:
        clientlib.env.append_value('CPPFLAGS', '-fvisibility=hidden')

    if bld.env['IS_MACOSX']:
        clientlib.env.append_value('CPPFLAGS', '-fvisibility=hidden')
        clientlib.env.append_value('LINKFLAGS', '-single_module')

    if bld.env['IS_SUN']:
        clientlib.env.append_value('LINKFLAGS', '-lnsl -lsocket')

    if bld.variant:
        # if there is variant defined, we expect it to be the 32bit client lib one
        # we don't want to build other stuff in this variant
        return

    serverlib = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
    if bld.env['IS_MACOSX']:
        serverlib.framework = ['CoreAudio', 'CoreFoundation', 'Accelerate']
    serverlib.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
    serverlib.includes = includes
    serverlib.name = 'serverlib'
    serverlib.target = 'jackserver'+libsuffix
    serverlib.install_path = '${LIBDIR}'
    serverlib.use = uselib
    if bld.env['IS_WINDOWS']:
        serverlib.env['cxxshlib_PATTERN'] = 'lib%s.dll'
        serverlib.env['cxxstlib_PATTERN'] = 'lib%s.a'
        serverlib.env['implib_PATTERN'] = 'lib%s.dll.a'
        if staticbuild:
            serverlib.env['SHLIB_MARKER'] = ''
        serverlib.env.append_value('LINKFLAGS', ['-static-libstdc++', '--disable-auto-import'])
        serverlib.env.append_value('LINKFLAGS', ['-Wl,--output-def,lib%s.def' % serverlib.target])
        bld.install_files(serverlib.install_path, [os.path.join(buildbindir, 'lib%s.def' % serverlib.target)])
    serverlib.source = [] + common_libsources
    serverlib.source += [
        'JackAudioDriver.cpp',
        'JackTimedDriver.cpp',
        'JackMidiDriver.cpp',
        'JackDriver.cpp',
        'JackEngine.cpp',
        'JackExternalClient.cpp',
        'JackFreewheelDriver.cpp',
        'JackInternalClient.cpp',
        'JackInternalSessionLoader.cpp',
        'JackServer.cpp',
        'JackThreadedDriver.cpp',
        'JackRestartThreadedDriver.cpp',
        'JackWaitThreadedDriver.cpp',
        'JackWaitCallbackDriver.cpp',
        'JackServerAPI.cpp',
        'JackDriverLoader.cpp',
        'JackServerGlobals.cpp',
        'JackControlAPI.cpp',
        'JackNetTool.cpp',
        'JackNetInterface.cpp',
        'JackArgParser.cpp',
        'JackRequestDecoder.cpp',
        'JackMidiAsyncQueue.cpp',
        'JackMidiAsyncWaitQueue.cpp',
        'JackMidiBufferReadQueue.cpp',
        'JackMidiBufferWriteQueue.cpp',
        'JackMidiRawInputWriteQueue.cpp',
        'JackMidiRawOutputWriteQueue.cpp',
        'JackMidiReadQueue.cpp',
        'JackMidiReceiveQueue.cpp',
        'JackMidiSendQueue.cpp',
        'JackMidiUtil.cpp',
        'JackMidiWriteQueue.cpp',
        'JackMetadata.cpp',
        ]

    if bld.env['IS_LINUX']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_FREEBSD']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_SUN']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_MACOSX']:
        serverlib.source += [

=== dbus/wscript ===
#! /usr/bin/python3
# encoding: utf-8

import os.path
import re # subst_func

from waflib import Logs, Options

def options(opt):
    opt.add_option('--enable-pkg-config-dbus-service-dir', action='store_true', default=False, help='force D-Bus service install dir to be one returned by pkg-config')

def configure(conf):
    conf.env['BUILD_JACKDBUS'] = False
    conf.define('JACK_VERSION', conf.env['JACK_VERSION'])

    if not conf.check_cfg(package='dbus-1 >= 1.0.0', args='--cflags --libs', mandatory=False):
        print(Logs.colors.RED + 'ERROR !! jackdbus will not be built because libdbus-dev is missing' + Logs.colors.NORMAL)
        return

    dbus_dir = conf.check_cfg(package='dbus-1', args='--variable=session_bus_services_dir')
    if not dbus_dir:
        print(Logs.colors.RED + 'ERROR !! jackdbus will not be built because service dir is unknown' + Logs.colors.NORMAL)
        return

    dbus_dir = dbus_dir.strip()
    conf.env['DBUS_SERVICES_DIR_REAL'] = dbus_dir

    if Options.options.enable_pkg_config_dbus_service_dir:
        conf.env['DBUS_SERVICES_DIR'] = dbus_dir
    else:
        conf.env['DBUS_SERVICES_DIR'] = os.path.normpath(conf.env['PREFIX'] + '/share/dbus-1/services')

    if not conf.check_cfg(package='expat', args='--cflags --libs', mandatory=False):
        print(Logs.colors.RED + 'ERROR !! jackdbus will not be built because of expat is missing' + Logs.colors.NORMAL)
        return

    conf.env['BUILD_JACKDBUS'] = True

def build(bld):
    obj = bld(features = ['c', 'cprogram'], idx=17)
    if bld.env['IS_LINUX']:
        sysdeps_dbus_include = ['../linux', '../posix']
    if bld.env['IS_FREEBSD']:
        sysdeps_dbus_include = ['../freebsd', '../posix']
    if bld.env['IS_MACOSX']:
        sysdeps_dbus_include = ['../macosx', '../posix']

    obj.includes = sysdeps_dbus_include + ['.', '../', '../common', '../common/jack']
    obj.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
    obj.source = [
        'jackdbus.c',
        'controller.c',
        'params.c',
        'controller_iface_configure.c',
        'controller_iface_control.c',
        'controller_iface_introspectable.c',
        'controller_iface_patchbay.c',
        'controller_iface_session_manager.c',
        'controller_iface_transport.c',
        'xml.c',
        'xml_expat.c',
        #'xml_nop.c',
        'xml_write_raw.c',
        'sigsegv.c',
        'reserve.c',
        ]
    obj.use = ['serverlib']
    if bld.env['IS_LINUX']:
        obj.source += [
            '../linux/uptime.c',
        ]
        obj.use += ['PTHREAD', 'DL', 'RT', 'DBUS-1', 'EXPAT', 'STDC++']
    if bld.env['IS_FREEBSD']:
        obj.source += [
            '../linux/uptime.c',
        ]
        obj.use += ['PTHREAD', 'EXECINFO', 'LIBSYSINFO', 'DBUS-1', 'EXPAT']
    if bld.env['IS_MACOSX']:
        obj.source += [
            '../macosx/uptime.c',
        ]
        obj.use += ['PTHREAD', 'DL', 'DBUS-1', 'EXPAT']
    obj.target = 'jackdbus'

    # process org.jackaudio.service.in -> org.jackaudio.service
    obj = bld(
            features = 'subst',
            source = 'org.jackaudio.service.in',
            target = 'org.jackaudio.service',
            install_path = '${DBUS_SERVICES_DIR}/',
            BINDIR = bld.env['PREFIX'] + '/bin')

    if not bld.env['IS_WINDOWS']:
        bld.install_files('${PREFIX}/bin', 'jack_control', chmod=0o755)

=== example-clients/wscript ===
#! /usr/bin/python3
# encoding: utf-8

example_programs = {
    'jack_cpu_load' : 'cpu_load.c',
    'jack_latent_client' : 'latent_client.c',
    'jack_metro' : 'metro.c',
    'jack_midi_latency_test' : 'midi_latency_test.c',
    'jack_midiseq' : 'midiseq.c',
    'jack_midisine' : 'midisine.c',
    'jack_net_master' : 'netmaster.c',
    'jack_net_slave' : 'netslave.c',
    'jack_server_control' : 'server_control.cpp',
    'jack_showtime' : 'showtime.c',
    'jack_simdtests' : 'simdtests.cpp',
    'jack_simple_client' : 'simple_client.c',
    'jack_simple_session_client' : 'simple_session_client.c',
    'jack_thru' : 'thru_client.c',
    'jack_zombie' : 'zombie.c',
    }

example_libs = {
    'inprocess' : 'inprocess.c',
    }

def configure(conf):
    conf.env['BUILD_EXAMPLE_CLIENT_REC'] = conf.env['SNDFILE']

def build(bld):
    if bld.env['IS_LINUX']:
        os_incdir = ['../linux', '../posix']
    if bld.env['IS_MACOSX']:
        os_incdir = ['../macosx', '../posix']
    if bld.env['IS_FREEBSD']:
        os_incdir = ['../freebsd', '../posix']
    if bld.env['IS_SUN']:
        os_incdir = ['../solaris', '../posix']
    if bld.env['IS_WINDOWS']:
        os_incdir = ['../windows']
    for example_program, example_program_source in list(example_programs.items()):
        if example_program == 'jack_server_control':
            use = ['serverlib', 'STDC++']
        elif example_program == 'jack_net_slave':
            if not bld.env['BUILD_NETLIB']:
                continue
            use = ['netlib']
        elif example_program == 'jack_net_master':
            if not bld.env['BUILD_NETLIB']:
                continue
            use = ['netlib']
        else:
            use = ['clientlib']

        if example_program == 'jack_simdtests':
            ftrs = 'cxx cxxprogram'
        else:
            ftrs = 'c cprogram'

        if bld.env['IS_MACOSX']:
            prog = bld(features = ftrs, framework = ['Foundation'])
        else:
            prog = bld(features = ftrs)
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = example_program_source
        prog.use = use
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'M']
        if bld.env['IS_SUN']:
            prog.use += ['M']
        if bld.env['IS_FREEBSD']:
            prog.use += ['M']
        if bld.env['IS_WINDOWS'] and bld.env['BUILD_STATIC']:
            prog.env['LIB_PTHREAD'] = [':libwinpthread.a']
        #prog.cflags = ['-Wno-deprecated-declarations', '-Wno-misleading-indentation']
        #prog.cxxflags = ['-Wno-deprecated-declarations', '-Wno-misleading-indentation']

        prog.target = example_program

    if bld.env['BUILD_EXAMPLE_CLIENT_REC']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'capture_client.c'
        prog.use = ['clientlib']
        if bld.env['IS_MACOSX']:
            prog.use += ['SNDFILE']
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'SNDFILE']
        if bld.env['IS_FREEBSD']:
            prog.use += ['SNDFILE']
        if bld.env['IS_SUN']:
            prog.use += ['RT', 'SNDFILE']
        if bld.env['IS_WINDOWS']:
            prog.uselib = ['SNDFILE']
            if bld.env['BUILD_STATIC']:
                prog.env['LIB_PTHREAD'] = [':libwinpthread.a']
        prog.target = 'jack_rec'

    for example_lib, example_lib_source in list(example_libs.items()):
        lib = bld(features = 'c cshlib')
        if not bld.env['IS_WINDOWS']:
            lib.env['cshlib_PATTERN'] = '%s.so'
        lib.includes = os_incdir + ['../common/jack', '../common']
        lib.target = example_lib
        lib.source = example_lib_source
        if bld.env['IS_SUN']:
            lib.env.append_value('LINKFLAGS', '-lm')
        if bld.env['IS_WINDOWS'] and bld.env['BUILD_STATIC']:
            prog.env['LIB_PTHREAD'] = [':libwinpthread.a']
        lib.use = 'serverlib'
        lib.install_path = '${ADDON_DIR}/'

=== man/wscript ===
#! /usr/bin/python3
# encoding: utf-8


def build(bld):
    bld.exec_command('cd man ; sh fill_template {} {}'.format(
        bld.env['JACK_VERSION'],
        bld.env['HAVE_JACK_EXAMPLE_TOOLS'])
    )
    bld.install_files(bld.env['MANDIR'], bld.path.ant_glob('*.1'))

=== tests/wscript ===
#! /usr/bin/python3
# encoding: utf-8

test_programs = {
    # For testing purposes
    #'synchroClient': ['testSynchroClient.cpp'],
    #'synchroServer': ['testSynchroServer.cpp'],
    #'synchroServerClient': ['testSynchroServerClient.cpp'],
    #'testSem': ['testSem.cpp'],
    'jack_test': ['test.cpp'],
    'jack_cpu': ['cpu.c'],
    'jack_iodelay': ['iodelay.cpp'],
    'jack_multiple_metro' : ['external_metro.cpp'],
    }

def build(bld):
    for test_program, test_program_sources in list(test_programs.items()):
        prog = bld(features = 'cxx cxxprogram')
        if bld.env['IS_MACOSX']:
            prog.includes = ['..','../macosx', '../posix', '../common/jack', '../common']
        if bld.env['IS_LINUX']:
            prog.includes = ['..','../linux', '../posix', '../common/jack', '../common']
        if bld.env['IS_FREEBSD']:
            prog.includes = ['..','../freebsd', '../posix', '../common/jack', '../common']
        if bld.env['IS_SUN']:
            prog.includes = ['..','../solaris', '../posix', '../common/jack', '../common']
        prog.source = test_program_sources
        if bld.env['IS_LINUX']:
            prog.uselib = 'RT'
        prog.use = 'clientlib'
        prog.target = test_program
        #prog.cxxflags = ['-Wno-deprecated-declarations']

=== tools/wscript ===
#! /usr/bin/python3
# encoding: utf-8

example_tools = {
    'jack_alias' : 'alias.c',
    'jack_bufsize' : 'bufsize.c',
    'jack_connect' : 'connect.c',
    'jack_evmon' : 'evmon.c',
    'jack_freewheel' : 'freewheel.c',
    'jack_load' : 'ipload.c',
    'jack_lsp' : 'lsp.c',
    'jack_midi_dump' : 'midi_dump.c',
    'jack_monitor_client' : 'monitor_client.c',
    'jack_property' : 'property.c',
    'jack_samplerate' : 'samplerate.c',
    'jack_session_notify' : 'session_notify.c',
    'jack_unload' : 'ipunload.c',
    'jack_wait' : 'wait.c',
    }

def configure(conf):
    conf.env['BUILD_TOOL_ALSA_IO'] = conf.env['SAMPLERATE'] and conf.env['BUILD_DRIVER_ALSA']
    conf.env['BUILD_TOOL_CLIENT_TRANSPORT'] = conf.env['READLINE']
    conf.env['BUILD_TOOL_CLIENT_NETSOURCE'] = conf.env['CELT'] or conf.env['OPUS']
    conf.env['BUILD_TOOL_ZALSA'] = conf.env['ZALSA']

def build(bld):
    if bld.env['IS_LINUX']:
        os_incdir = ['../linux', '../posix']
    if bld.env['IS_MACOSX']:
        os_incdir = ['../macosx', '../posix']
    if bld.env['IS_FREEBSD']:
        os_incdir = ['../freebsd', '../posix']
    if bld.env['IS_SUN']:
        os_incdir = ['../solaris', '../posix']
    if bld.env['IS_WINDOWS']:
        os_incdir = ['../windows']
    for example_tool, example_tool_source in list(example_tools.items()):
        if bld.env['IS_MACOSX']:
            prog = bld(features='c cprogram', framework = ['Foundation'])
        else:
            prog = bld(features='c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = example_tool_source
        prog.use = ['clientlib']
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'M']
        if bld.env['IS_SUN']:
            prog.use += ['M']
        if bld.env['IS_WINDOWS'] and bld.env['BUILD_STATIC']:
            prog.env['LIB_PTHREAD'] = [':libwinpthread.a']
        #prog.cflags = ['-Wno-deprecated-declarations', '-Wno-misleading-indentation']
        #prog.cxxflags = ['-Wno-deprecated-declarations', '-Wno-misleading-indentation']

        prog.target = example_tool

    if bld.env['BUILD_TOOL_CLIENT_TRANSPORT']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'transport.c'
        prog.use = ['clientlib']
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'READLINE']
        if bld.env['IS_MACOSX']:
            prog.use += ['READLINE']
        if bld.env['IS_WINDOWS']:
            prog.use += ['READLINE']
            if bld.env['BUILD_STATIC']:
                prog.env['LIB_PTHREAD'] = [':libwinpthread.a']
        prog.target = 'jack_transport'

    if bld.env['BUILD_TOOL_CLIENT_NETSOURCE']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['.', '..', '../common/jack', '../common']
        prog.source = ['netsource.c', '../common/netjack_packet.c']
        prog.env.append_value('CFLAGS', '-DNO_JACK_ERROR')
        prog.use = ['CELT', 'SAMPLERATE', 'OPUS', 'M', 'clientlib']
        prog.target = 'jack_netsource'
        prog.defines = ['HAVE_CONFIG_H']

    if bld.env['IS_LINUX'] and bld.env['BUILD_TOOL_ALSA_IO']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['alsa_in.c', '../common/memops.c']
        prog.env.append_value('CFLAGS', '-DNO_JACK_ERROR')
        prog.use = ['clientlib', 'ALSA', 'SAMPLERATE', 'M']
        prog.target = 'alsa_in'

        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['alsa_out.c', '../common/memops.c']
        prog.env.append_value('CFLAGS', '-DNO_JACK_ERROR')
        prog.use = ['clientlib', 'ALSA', 'SAMPLERATE', 'M']
        prog.target = 'alsa_out'

    if bld.env['IS_LINUX'] and bld.env['BUILD_TOOL_ZALSA']:
        prog = bld(features = ['cxx', 'cxxshlib'])
        prog.defines = ['HAVE_CONFIG_H','SERVER_SIDE','APPNAME="zalsa_in"','VERSION="0.4.0"']
        prog.install_path = '${ADDON_DIR}/'
        prog.includes = os_incdir + ['../common/jack', '../common', 'zalsa']
        prog.source = ['zalsa/zita-a2j.cc', 'zalsa/alsathread.cc', 'zalsa/jackclient.cc', 'zalsa/pxthread.cc', 'zalsa/lfqueue.cc']
        prog.target = 'zalsa_in'
        prog.use = ['ZITA-ALSA-PCMI', 'ZITA-RESAMPLER', 'ALSA', 'M', 'RT', 'serverlib']
        prog.env['cxxshlib_PATTERN'] = '%s.so'

        prog = bld(features = ['cxx', 'cxxshlib'])
        prog.defines = ['HAVE_CONFIG_H','SERVER_SIDE','APPNAME="zalsa_out"','VERSION="0.4.0"']
        prog.install_path = '${ADDON_DIR}/'
        prog.includes = os_incdir + ['../common/jack', '../common', 'zalsa']
        prog.source = ['zalsa/zita-j2a.cc', 'zalsa/alsathread.cc', 'zalsa/jackclient.cc', 'zalsa/pxthread.cc', 'zalsa/lfqueue.cc']
        prog.target = 'zalsa_out'
        prog.use = ['ZITA-ALSA-PCMI', 'ZITA-RESAMPLER', 'ALSA', 'M', 'RT', 'serverlib']
        prog.env['cxxshlib_PATTERN'] = '%s.so'

    if not bld.env['IS_WINDOWS']:
        bld.symlink_as('${PREFIX}/bin/jack_disconnect', 'jack_connect')

=== debian/changelog ===
jackd2 (1.9.20~dfsg-1) unstable; urgency=medium

  * Team upload

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Erich Eickmeyer ]
  * Build without LTO Unfortunately, if built with LTO, jackd2 will hang and
    deny any client connection. Per
    https://github.com/jackaudio/jack2/issues/776

  [ Sebastian Ramacher ]
  * New upstream version 1.9.20~dfsg
  * debian/patches: Remove obsolete patch. Upstream supports SOURCE_DATE_EPOCH

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 23 Jan 2022 17:38:32 +0100

=== debian/control ===
Source: jackd2
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Adrian Knoth <adi@drcomp.erfurt.thur.de>,
           Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-sequence-python3,
               libasound2-dev (>= 1.0.18) [linux-any],
               libdb-dev,
               libdbus-1-dev,
               libexpat1-dev,
               libffado-dev (>= 2.0.0) [linux-any],
               libncurses-dev,
               libopus-dev,
               libraw1394-dev [linux-any],
               libreadline-dev,
               libsamplerate-dev,
               libsndfile1-dev,
               libsystemd-dev [linux-any],
               libzita-alsa-pcmi-dev,
               libzita-resampler-dev,
               po-debconf,
               python3:any
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://jackaudio.org/
Vcs-Git: https://salsa.debian.org/multimedia-team/jackd2.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/jackd2

Package: jackd2
Architecture: any
Replaces: jack-daemon, jackd (<< 3), libjack0 (<= 1.9.5~dfsg-13)
Provides: jack-daemon
Conflicts: jack-daemon, jackd (<< 3)
Depends: debconf | debconf-2.0,
         libjack-jackd2-0 (= ${binary:Version}),
         python3-dbus,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: jackd2-firewire [amd64 i386 powerpc], libpam-modules, qjackctl
Suggests: jack-tools, meterbridge
Description: JACK Audio Connection Kit (server and example clients)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the daemon jackd as well as some example clients.

Package: libjack-jackd2-0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: jackd2 (<< ${binary:Version}),
           jackd2 (>> ${binary:Version}),
           libjack-0.116,
           libjack-0.125,
           libjack0
Suggests: jackd2 (= ${binary:Version})
Provides: libjack-0.116, libjack-0.125
Replaces: libjack-0.116, libjack-0.125
Multi-Arch: same
Description: JACK Audio Connection Kit (libraries)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the shared libraries.

Package: jackd2-firewire
Architecture: amd64 i386 powerpc
Provides: jackd-firewire
Replaces: jackd-firewire
Conflicts: jackd-firewire
Depends: jackd2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: JACK Audio Connection Kit (FFADO backend)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the IEEE1394 (FireWire) backend FFADO.

Package: libjack-jackd2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libjack-jackd2-0 (= ${binary:Version}), pkg-config, ${misc:Depends}
Conflicts: libjack-dev, libjack0.100.0-dev (<< 0.102.20-2)
Provides: libjack-dev, libjack-dev-session, libjack0.100.0-dev
Replaces: libjack0.71.2-0 (<< 0.75.0-1)
Description: JACK Audio Connection Kit (development files)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains files needed for the development of JACK applications
 and an API reference.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk
export DEB_CFLAGS_MAINT_APPEND = -fno-lto
export DEB_CXXFLAGS_MAINT_APPEND = -fno-lto

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS = 1
endif

CONFIGURE_OPTIONS = $(if $(filter linux,$(DEB_HOST_ARCH_OS)),--alsa --dbus)
CONFIGURE_OPTIONS += $(if $(filter amd64 i386 powerpc,$(DEB_HOST_ARCH)),--firewire)

%:
	dh $@

override_dh_auto_configure:
	python3 ./waf configure \
		--prefix=/usr --classic \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		$(CONFIGURE_OPTIONS) \
		CC='$(CC)' CXX='$(CXX)' PKGCONFIG='$(PKG_CONFIG)'

override_dh_auto_build:
	python3 ./waf -v build --jobs=$(NUMJOBS)

override_dh_auto_install:
	python3 ./waf -v install --destdir=debian/tmp

override_dh_auto_clean:
	test -s ./waf && python3 ./waf -v distclean || true
	find . -name "*.pyc" -delete

override_dh_makeshlibs:
	dh_makeshlibs -Xinprocess -Xjack_alsa -Xjack_dummy

override_dh_python3:
	dh_python3 -pjackd2
